> For the complete documentation index, see [llms.txt](https://docs.coldstack.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.coldstack.io/http-api-compatible-with-amazon-s3/api-reference/bucket/putbucketversioning.md).

# PutBucketVersioning

Enables or pauses versioning of the bucket.

Versioning can be set to one of two statuses:

* `Enabled`: Turn on version management for objects in the bucket. All new objects added to the bucket get a unique version ID.
* `Suspended`: Suspends version management for objects in the bucket. All new objects added to the bucket get `null` as the version ID.

### Request

```
PUT /{bucket}?versioning HTTP/1.1
```

#### Path parameters

| Parameter | Description  |
| --------- | ------------ |
| `bucket`  | Bucket name. |

#### Query parameters

| Parameter    | Description                                              |
| ------------ | -------------------------------------------------------- |
| `versioning` | Required parameter that indicates the type of operation. |

#### Data schema

```
<?xml version="1.0" encoding="UTF-8"?>
<VersioningConfiguration>
   <Status>string</Status>
</VersioningConfiguration>
```

| Element  | Description                                                                                      |                      |
| -------- | ------------------------------------------------------------------------------------------------ | -------------------- |
| `Status` | <p>Status of the bucket versioning option.<br><br>Type: String<br>Possible values: <code>Enabled | Suspended</code></p> |

#### Headers

Use only [common request headers](/http-api-compatible-with-amazon-s3/api-reference/common-request-headers.md) in requests.

### Response

#### Headers

Responses can only contain [common response headers](/http-api-compatible-with-amazon-s3/api-reference/common-response-headers.md).

#### Response codes

For a list of possible responses, see [Responses](/http-api-compatible-with-amazon-s3/api-reference/answers.md).

A successful response does not contain any additional data.

<br>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.coldstack.io/http-api-compatible-with-amazon-s3/api-reference/bucket/putbucketversioning.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
